[idena-sdk-js](../README.md) / TransactionType

# Enumeration: TransactionType

## Table of contents

### Enumeration Members

- [ActivationTx](TransactionType.md#activationtx)
- [BurnTx](TransactionType.md#burntx)
- [CallContractTx](TransactionType.md#callcontracttx)
- [ChangeGodAddressTx](TransactionType.md#changegodaddresstx)
- [ChangeProfileTx](TransactionType.md#changeprofiletx)
- [DelegateTx](TransactionType.md#delegatetx)
- [DeleteFlipTx](TransactionType.md#deletefliptx)
- [DeployContractTx](TransactionType.md#deploycontracttx)
- [EvidenceTx](TransactionType.md#evidencetx)
- [InviteTx](TransactionType.md#invitetx)
- [KillDelegatorTx](TransactionType.md#killdelegatortx)
- [KillInviteeTx](TransactionType.md#killinviteetx)
- [KillTx](TransactionType.md#killtx)
- [OnlineStatusTx](TransactionType.md#onlinestatustx)
- [SendTx](TransactionType.md#sendtx)
- [StoreToIpfsTx](TransactionType.md#storetoipfstx)
- [SubmitAnswersHashTx](TransactionType.md#submitanswershashtx)
- [SubmitFlipTx](TransactionType.md#submitfliptx)
- [SubmitLongAnswersTx](TransactionType.md#submitlonganswerstx)
- [SubmitShortAnswersTx](TransactionType.md#submitshortanswerstx)
- [TerminateContractTx](TransactionType.md#terminatecontracttx)
- [UndelegateTx](TransactionType.md#undelegatetx)

## Enumeration Members

### ActivationTx

• **ActivationTx** = ``1``

#### Defined in

[models/transactions/transaction.ts:11](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L11)

___

### BurnTx

• **BurnTx** = ``12``

#### Defined in

[models/transactions/transaction.ts:22](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L22)

___

### CallContractTx

• **CallContractTx** = ``16``

#### Defined in

[models/transactions/transaction.ts:26](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L26)

___

### ChangeGodAddressTx

• **ChangeGodAddressTx** = ``11``

#### Defined in

[models/transactions/transaction.ts:21](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L21)

___

### ChangeProfileTx

• **ChangeProfileTx** = ``13``

#### Defined in

[models/transactions/transaction.ts:23](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L23)

___

### DelegateTx

• **DelegateTx** = ``18``

#### Defined in

[models/transactions/transaction.ts:28](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L28)

___

### DeleteFlipTx

• **DeleteFlipTx** = ``14``

#### Defined in

[models/transactions/transaction.ts:24](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L24)

___

### DeployContractTx

• **DeployContractTx** = ``15``

#### Defined in

[models/transactions/transaction.ts:25](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L25)

___

### EvidenceTx

• **EvidenceTx** = ``8``

#### Defined in

[models/transactions/transaction.ts:18](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L18)

___

### InviteTx

• **InviteTx** = ``2``

#### Defined in

[models/transactions/transaction.ts:12](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L12)

___

### KillDelegatorTx

• **KillDelegatorTx** = ``20``

#### Defined in

[models/transactions/transaction.ts:30](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L30)

___

### KillInviteeTx

• **KillInviteeTx** = ``10``

#### Defined in

[models/transactions/transaction.ts:20](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L20)

___

### KillTx

• **KillTx** = ``3``

#### Defined in

[models/transactions/transaction.ts:13](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L13)

___

### OnlineStatusTx

• **OnlineStatusTx** = ``9``

#### Defined in

[models/transactions/transaction.ts:19](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L19)

___

### SendTx

• **SendTx** = ``0``

#### Defined in

[models/transactions/transaction.ts:10](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L10)

___

### StoreToIpfsTx

• **StoreToIpfsTx** = ``21``

#### Defined in

[models/transactions/transaction.ts:31](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L31)

___

### SubmitAnswersHashTx

• **SubmitAnswersHashTx** = ``5``

#### Defined in

[models/transactions/transaction.ts:15](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L15)

___

### SubmitFlipTx

• **SubmitFlipTx** = ``4``

#### Defined in

[models/transactions/transaction.ts:14](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L14)

___

### SubmitLongAnswersTx

• **SubmitLongAnswersTx** = ``7``

#### Defined in

[models/transactions/transaction.ts:17](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L17)

___

### SubmitShortAnswersTx

• **SubmitShortAnswersTx** = ``6``

#### Defined in

[models/transactions/transaction.ts:16](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L16)

___

### TerminateContractTx

• **TerminateContractTx** = ``17``

#### Defined in

[models/transactions/transaction.ts:27](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L27)

___

### UndelegateTx

• **UndelegateTx** = ``19``

#### Defined in

[models/transactions/transaction.ts:29](https://github.com/idena-network/idena-sdk-js/blob/master/src/models/transactions/transaction.ts#L29)
